package jasymca;

import jasymca.*;

import java.util.*;
import java.io.*;
import java.net.URL;


/**
 * This is for a text version
 * @author sergei
 *
 */
public class JasymcaConsoleText { 

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	Vector<String> history;
	private int history_index;
	private int max_histSize = 1000;
	private ConsoleInputStream in;
	private PrintStream out;
	private Hashtable params = null;
	private Jasymca jas = null;
  //  static public jhplot.HChart hChartJasymca=null;
	// public static XYSeriesCollection datasetCollection;
	// public static XYIntervalSeriesCollection  datasetInterval;

    

	public JasymcaConsoleText(InputStream inStream, PrintStream outStream) {
		history = new Vector<String>();
		history.addElement("");
		history_index = 0;
		
		
		// in = new ConsoleInputStream();
                // ByteArrayOutputStream baos = new ByteArrayOutputStream();
                /*
                ByteArrayOutputStream f = new ByteArrayOutputStream();
                String s = "printf(\"OK\");";
                byte buf[] = s.getBytes();

                try { 
                    f.write(buf); 
                    out = new PrintStream(f);
                } catch (Exception e) {}
                */

                params=new Hashtable(); 
                String ui = "Octave";
                jas = new Jasymca(ui);
                jas.setup_ui("Octave", false);
                jas.welcome = "Restarting in Octave mode.\n";
                // jas.setup_ui("Maxima", false);
                // jas.welcome = "Restarting in Maxima mode.\n";
                // jas.start(in, out);               
                 jas.start(inStream, outStream); 
                
                 
	}

	
	public void setInput(InputStream s){
		
		jas.start(in, out);
		
	}


	void back_history() {
		if (history_index > 0 && history_index <= history.size()) {
			history_index--;
			String insert = (String) history.elementAt(history_index);
		}
	}

	void forth_history() {
		if (history_index >= -1 && history_index < history.size() - 1) {
			history_index++;
			String insert = (String) history.elementAt(history_index);
		} else if (history_index == history.size() - 1) {
			history_index++;
		}
	}


       // as readScript but without thread
       public void readScriptFile(File file) {
              //  if (jas == null || jas.evalLoop == null || !jas.evalLoop.isAlive()) {
                   //     out.println("Processor not running.\n");
                  //      return;
              //  }
                 if (jas == null) return;
        
                 try {
                                // System.out.println("Reading " + file.getName() + " ....");
                    //            out.print("Reading " + file.getName() + " ....");
                                LambdaLOADFILE.readFile(new FileInputStream(file));
                     //           out.println("...finished.");
                        } catch (Exception e) {
                                out.println("Error reading file " + file.getName());
                        }

        
       }



	public void readScript(File file) {

                if (jas == null) return;
/*
		if (jas == null || jas.evalLoop == null || !jas.evalLoop.isAlive()) {
			out.println("Processor not running.\n");
			return;
		}
*/
		new Thread(new FileLoader(file)).start();
	}

	class FileLoader implements Runnable {
		File file;

		public FileLoader(File file) {
			this.file = file;
		}

		public void run() {
			try {
                // System.out.println("Reading " + file.getName() + " ....");
				//out.print("Reading " + file.getName() + " ....");
				LambdaLOADFILE.readFile(new FileInputStream(file));
				// out.println("...finished.");
			} catch (Exception e) {
				// out.println("Error reading file " + file.getName());
			}
		}
	}

	/**
	 * Reading a stream
	 * 
	 * @param file
	 */
	public void readStream(InputStream file) throws Exception  {
                /*
		if (jas == null || jas.evalLoop == null || !jas.evalLoop.isAlive()) {
		//	out.println("Processor not running.\n");
			return;
		}
		// new Thread(new FileLoaderStream(file)).start();
                */

                if (jas == null) return;
                LambdaLOADFILE.readFile(file);

	}

/*
	class FileLoaderStream implements Runnable {
		InputStream file;

		public FileLoaderStream(InputStream file) {
			this.file = file;
		}

		public void run() {
			try {
				out.print("Reading examples....");
				LambdaLOADFILE.readFile(file);
				out.println("...finished.");
			} catch (Exception e) {
				out.println(e);
				out.println("Error reading stream");
			}
		}
	}
*/

	public void saveHistory(File file) {
		try {
			FileOutputStream f = new FileOutputStream(file);
			for (int i = 0; i < history.size(); i++)
				f.write(((String) history.elementAt(i) + "\n").getBytes());
			f.close();
		} catch (Exception e) {
			out.println("Error writing file " + file.getName());
		}
	}

	public void warn_permissions() {
		out
				.println("\nReading and writing files is not allowed on this computer.");
		out.println("See the documentation for setting permissions.");
	}



     
        public void restart(){
                        String ui = "Octave";
                        jas = new Jasymca(ui);
                        // jas.setup_ui(null, true);
                        // jas.welcome = "Restarting with clean environment.\n";
                        jas.start(in, out);

        }


	/**
	 * Evaluate expression
	 */

/*
	public void eval(String inString) {

		if (inString.equalsIgnoreCase("demo")) {
			// InputStream in = getClass().getResourceAsStream("jasymca/m/demoEN.m");
                        InputStream in = getClass().getResourceAsStream("m/demoEN.m");
			readStream(in);
			return;

		}

		history.addElement(inString);
		history_index = history.size();
		out.println(inString);

	}
*/

        public PrintStream getOut(){
        	
        return out;

        }
        
        
        

}
