package jasymca;

class LambdaABS extends LambdaAlgebraic{
 public LambdaABS(){
  diffrule = "sign(x)";
  intrule = "sign(x)*x^2/2";
 }

 Algebraic f_exakt(Algebraic x) throws JasymcaException{
  if(x instanceof jasymca.Zahl)
   return f((Zahl)x);
  return FunctionVariable.create( "sqrt", x.mult( x.cc() ));
 }

 Zahl f( Zahl x) throws JasymcaException{
  return new Unexakt(x.norm());
 }
}


/*
@GROUP
matrix
@SYNTAX
abs(value)
@DOC
Returns the absolute positive value of value.
@NOTES
@EXAMPLES
<programlisting>
abs(-5)     = 5
abs(2)      = 2
abs(3 + 4I) = 5
</programlisting>
@SEE
sign, angle
*/
