package jasymca;

import jasymca.*;
import java.util.Stack;
import jasymca.Lambda.*;


class LambdaADDPATH extends Lambda{
 public int lambda(Stack st) throws ParseException, JasymcaException{
  int narg = getNarg( st );
  while(narg-- > 0){
   Object s = st.pop();
   if( !(s instanceof java.lang.String) )
    throw new JasymcaException("Usage: ADDPATH( dir1, dir2, ... )");
   pc.env.addPath( ((String)s).substring(1) );
  }
  return 0;
 }
}

/*
@GROUP
system
@SYNTAX
addpath(path)
@DOC
Adds path to the current search path.
@NOTES
@EXAMPLES
addpath("../newpath")
@SEE
path, rmpath
*/

