package jasymca;

import java.util.Stack;

public abstract class LambdaAlgebraic extends Lambda{
	
	// LambdaAlgebraic has functions for Algebraic variables
	// This class is used for numeric functions (sin,exp, etc)
	// for operators (+,-,..) and for many internal functions	
	
 public int lambda(Stack st) throws ParseException, JasymcaException{
  int narg = getNarg( st );
  switch(narg) {
   case 0:
    throw new JasymcaException("Lambda functions expect argument.");
   case 1:
    Algebraic arg = getAlgebraic( st );
    st.push( arg.map_lambda( this, null ) );
    break;
   case 2:
    Algebraic arg2 = getAlgebraic( st );
    Algebraic arg1 = getAlgebraic( st );
    arg1 = arg1.promote( arg2 );
    st.push( arg1.map_lambda( this, arg2 ));
    break;
   default:
    Algebraic args[] = new Algebraic[narg];
    for(int i=narg-1; i>=0; i--){
     args[i] = getAlgebraic( st );
    }
    st.push( f_exakt(args) );
    break;
  }
  return 0;
 }


 /* Conveniance function for single variate functions
	*/
 Zahl f(Zahl x) throws JasymcaException{ return x;}

 Algebraic f_exakt(Algebraic x) throws JasymcaException{ return null;}
 Algebraic f_exakt(Algebraic x, Algebraic y) throws JasymcaException{ return null;}
 Algebraic f_exakt(Algebraic[] x) throws JasymcaException{ return null;}

 protected String diffrule=null;
protected String intrule=null;
protected String trigrule = null;

 public Algebraic integrate(Algebraic arg, Variable x) throws JasymcaException{
  if(!(arg.depends(x)))
   throw new JasymcaException("Expression in function does not depend on Variable.");
  if( !(arg instanceof jasymca.Polynomial) || ((Polynomial)arg).degree()!=1 ||
   !((Polynomial)arg).ratfunc(x) || intrule==null)
   throw new JasymcaException("Can not integrate function ");
  try{
   Algebraic y = evalx( intrule, arg );
   // * dx/dz <----> /a[1]
   return y.div(((Polynomial)arg).a[1]);
  }catch(Exception e){
    throw new JasymcaException("Error integrating function");
  }
 }

}