package jasymca;

import java.util.Stack;

class LambdaCLEAR extends Lambda{
 public int lambda(Stack st) throws ParseException, JasymcaException{
  int nargs = getNarg( st );
  while( nargs-- > 0 ){
   Object arg = st.pop();
   if( arg instanceof java.lang.String){
    String s = ((String)arg).substring(1);
    pc.env.remove(s);
   }
  }
  return 0;
 }
}


/*
@GROUP
general
@SYNTAX
clear(variable)
@DOC
Clears the specified variable or, if blank, clears all variables.
clear()clears local variables
clear("variables") clears local variables
clear("globals") clears global variables
clear("functions"" clear function cache
clear("all") clear local variables, global variables and function cache
@EXAMPLE
<programlisting>
clear('x'); 
clear();
</programlisting>
@NOTES
The variable should be given as a string containing the variable name.
@SEE
who, whos
*/
