package jasymca;

import java.util.Stack;

class LambdaCOEFF extends Lambda{
	// COEFF
	// coeff(a,b,c) Koeffizienten von b der Potenz C in Ausdruck a.	
 public int lambda(Stack st) throws ParseException, JasymcaException{
  int narg = getNarg( st );
  if(narg!=3)
   throw new ParseException("Usage: COEFF (a, b, c), find coeff of b^c in a");
  Polynomial a = getPolynomial(st);
  Variable b = getVariable(st);
  Algebraic c_in = getAlgebraic(st);
  if(c_in.scalarq())
   st.push( a.coefficient( b, getInteger( c_in ) ));
  else if(c_in instanceof jasymca.Vektor){
   Vektor c = (Vektor)c_in;
   Algebraic v[] = new Algebraic[c.length()];
   for(int i=0; i<v.length; i++){
    v[i] = a.coefficient( b, getInteger( c.get(i) ));
   }
   st.push( new Vektor(v));
  }else
   throw new ParseException("Usage: COEFF (a, b, c), find coeff of b^c in a");
  return 0;
 }
}