package jasymca;

import java.util.Stack;

class LambdaDIFF extends Lambda{
 public int lambda(Stack st) throws ParseException, JasymcaException{
  int narg = getNarg( st );
  if(narg==0)
   throw new ParseException("Argument to diff missing.");
  Algebraic f = getAlgebraic(st); // Function to differentiate
  Variable v;
  if(narg>1){
   v = getVariable(st);
  }else{
   if( f instanceof jasymca.Polynomial )
    v = ((Polynomial)f).var;
   else if(f instanceof jasymca.Rational )
    v = ((Rational)f).den.var;
   else
    throw new ParseException("Could not determine Variable.");
  }
  Algebraic df = f.deriv(v);
  if(df instanceof jasymca.Rational && !df.exaktq())
   df = new LambdaRAT().f_exakt(df);
  st.push( df );
  return 0;
 }
}