package jasymca;

import java.util.Stack;




class LambdaDISP extends Lambda{
	 public int lambda(Stack st) throws ParseException, JasymcaException{
	  disp( st );
	  return 0;
	 }

	 static void disp( Stack st )throws ParseException, JasymcaException{

	  int narg = getNarg( st );
	  Object s_in = st.pop();
	  if(!(s_in instanceof java.lang.String) )
	   throw new JasymcaException("Argument to DISP must be string.");
	  String fmt = (String)s_in;
	  int idx, i=1;
	  String cs = "%f";

	  while( (idx = fmt.indexOf( cs )) != -1 && !st.empty() && narg-- > 1) {
	   Object n = st.pop();
	   if(n != null){
	    StringBuffer sb = new StringBuffer( fmt );
	    sb.delete( idx, idx+cs.length() );
	    sb.insert( idx, n.toString() );
	    fmt = sb.toString();
	   }else
	    break;
	  }

	  while( (idx = fmt.indexOf( "\\n" )) != -1 ) {
	   StringBuffer sb = new StringBuffer( fmt );
	   sb.delete( idx, idx+"\\n".length() );
	   sb.insert( idx, "\n" );
	   fmt = sb.toString();
	  }

	  if(pc.ps != null){
	   pc.ps.print( fmt.toString()+"\n" ); // chekanov 
	  
	  }
	 }
	}

/*
@GROUP
system
@SYNTAX
disp(string1, string2, string3, ...)
@DOC
This displays a set of lines of text.
@NOTES
@EXAMPLES
disp("Hello")
Hello
@SEE
*/

