package jasymca;

import java.util.Stack;

class LambdaDIVIDE extends Lambda{
	// Divide and remainder of two polynomials	
 public int lambda(Stack st) throws ParseException, JasymcaException{
  int size = getNarg( st );
  if(size!=3 && size!=2)
   throw new ParseException("Usage: DIVIDE (p1, p2, var)");
  Algebraic p1 = getAlgebraic(st);
  if(!p1.exaktq())
   p1 = new LambdaRAT().f_exakt(p1);
  Algebraic p2 = getAlgebraic(st);
  if(!p2.exaktq())
   p2 = new LambdaRAT().f_exakt(p2);
  Algebraic a[] = { p1, p2 };
  if(size==3){
   Variable v = getVariable(st);
   Poly.polydiv( a, v);
  }else{
   if(p1 instanceof jasymca.Zahl && p2 instanceof jasymca.Zahl)
    a = ((Zahl)p1).div( p2, a) ;
   else{
    a[0] = Poly.polydiv( p1, p2 );
    a[1] = p1.sub(a[0].mult(p2));
   }
  }
  st.push(new Vektor(a));
  return 0;
 }
}