package jasymca;

import java.util.List;
import java.util.Stack;

// Define Function. Example f(x):=3*x^2+2;
// Functions are stored as evaluated (compiled) Algebraics 
// Functions can be differentiated, integrated or used in symbolic equations
class LambdaFUNC extends Lambda{
 public int lambda(Stack st) throws ParseException,JasymcaException{
  int narg = getNarg( st );
  if(narg!=3)
   throw new ParseException("Wrong function definition.");
//p("func:"+x);

  List ret = getList( st );
  List prot = getList( st );
  if( prot.size() < 1 || !(prot.get(prot.size()-1) instanceof java.lang.String) )
   throw new ParseException("Wrong function definition.");
  String fname = ((String)prot.get(prot.size()-1)).substring(1);
  List vars_in = prot.subList(0, prot.size()-1);
  List code_in = getList( st );

  // 1. in variable names
  SimpleVariable vars[] = null;
  if( vars_in.size() != 0 ){
   int fnarg = ((Integer)vars_in.get( vars_in.size()-1 )).intValue();
   vars = new SimpleVariable[ fnarg ];
   for(int i=0; i<vars.length; i++){
    vars[i] = new SimpleVariable( (String)vars_in.get(vars.length-i-1) );
   }
  }
  SimpleVariable result = new SimpleVariable( ((String)ret.get(0)).substring(1));

  Lambda func = null;
  Environment env = new Environment();
  Stack ups = new Stack();

  // Add variables to environment
  for(int i=0; i<vars.length; i++){
   env.putValue( vars[i].name, new Polynomial( vars[i] ) );
//				vars[i] = new SimpleVariable( (String)vars_in.get(i) );
  }

  Object y = null;
  if( vars.length==1 ){
   int res = UserProgram.process_block( code_in, ups, env, true );
   if( res != Processor.ERROR ){
    y = env.getValue( result.name );
   }
  }

  if( y instanceof jasymca.Algebraic ){
   func = new UserFunction( fname, vars, (Algebraic)y, result, env );
  }else{
   func = new UserProgram( fname, vars, code_in, result, env, ups );
  }
  pc.env.putValue(fname, func);
  st.push( func );
  return 0;
 }
}