package jasymca;

import java.util.Stack;

// GCD for numbers and polynomials
class LambdaGCD extends Lambda{
 public int lambda(Stack st) throws ParseException, JasymcaException{
  // Variable definition, store in Prefix format and return success
  int narg = getNarg( st );
  if(narg<2)
   throw new ParseException("GCD requires at least 2 arguments.");
  Algebraic gcd = getAlgebraic(st);
  for(int i=1; i<narg; i++){
   gcd = gcd(gcd, getAlgebraic(st));
  }
  st.push( gcd );
  return 0;
 }

 Algebraic gcd(Algebraic x, Algebraic y) throws JasymcaException{
  if(!x.exaktq())
   x = new LambdaRAT().f_exakt(x);
  if(!y.exaktq())
   y = new LambdaRAT().f_exakt(y);
  if(x instanceof jasymca.Zahl && y instanceof jasymca.Zahl){
   return ((Zahl)x).gcd((Zahl)y);
  }
  if(x instanceof jasymca.Polynomial){
   Zahl gcd_x = ((Polynomial)x).gcd_coeff();
   if(y instanceof jasymca.Polynomial){ // poly_gcd * coef_gcd
    Zahl gcd_y = ((Polynomial)y).gcd_coeff();
    return Poly.poly_gcd(x,y).mult(gcd_x.gcd(gcd_y));
   }if(y instanceof jasymca.Zahl){
    return gcd_x.gcd( (Zahl)y );
   }
  }
  if(y instanceof jasymca.Polynomial && x instanceof jasymca.Zahl)
   return gcd(y,x);
  throw new JasymcaException("Not implemented.");
 }
}