package jasymca;

import java.util.Stack;

class LambdaRAT extends LambdaAlgebraic{
	// Rationalize all numbers, user function	
 public int lambda(Stack st) throws ParseException, JasymcaException{
  int narg = getNarg( st );
  Algebraic arg = getAlgebraic(st).reduce();
  if(arg instanceof jasymca.Unexakt)
   st.push (f((Zahl)arg));
  else if(arg instanceof jasymca.Exakt)
   st.push( arg );
  else
   st.push( FunctionVariable.create(
    getClass().getName().substring("jasymca.Lambda".length()).toLowerCase(), arg));
  return 0;
 }
 Algebraic f_exakt(Algebraic x) throws JasymcaException{
  if(x instanceof jasymca.Zahl) return (Zahl)x.rat();
  return x.map(this);
 }
 Zahl f( Zahl x) throws JasymcaException{
  return (Zahl)x.rat();
 }
}

/*
@GROUP
general
@SYNTAX
answer = rat(value)
@DOC
Find a rational approximation within the tolerance defined
by eps (default 10^{-8}  using a continued fraction expansion.
@EXAMPLES
rat(0.333333333) = 1/3 
@SEE
*/

