package jasymca;

class LambdaSIGN extends LambdaAlgebraic{
 public LambdaSIGN(){
  diffrule = "x-x"; // 0 geht nicht wegen parser: korrigieren!
  intrule = "x*sign(x)";
 }

 Algebraic f_exakt(Algebraic x) throws JasymcaException{
  if(x instanceof jasymca.Zahl)
   return f((Zahl)x);
  return null;
 }

 Zahl f( Zahl x) throws JasymcaException{
  return x.smaller(Zahl.ZERO)?Zahl.MINUS:Zahl.ONE;
 }
}


/*
@GROUP
general
@SYNTAX
sign(value)
@DOC
Returns the sign of value.
@EXAMPLES
<programlisting>
sign(-10)  = -1
sign(10)   = 1
sign(3+2i) = 0.832 + 0.555i 
</programlisting>
@NOTES
The sign of a complex number is calculated as sign(x) = x./abs(x)
@SEE
abs
*/
