package jasymca;

import java.util.Stack;

class LambdaSUBST extends Lambda{
	// SUBST (a, b, c), substitutes a for b in c
	// if c evaluates to a prefix expressions, substitute using parser
	// if c evaluates to Algebraic and b is SimpleVariable, substitute using value()
	// if c evaluates to Algebraic and b is not SimpleVariable, 
	// convert c and b to prefix and substitute using parser	
 public int lambda(Stack st) throws ParseException, JasymcaException{
  int narg = getNarg( st );
  if(narg!=3)
   throw new ParseException("Usage: SUBST (a, b, c), substitutes a for b in c");
  Algebraic a = getAlgebraic(st);
  Polynomial b = getPolynomial(st);
  Algebraic c = getAlgebraic(st);

  // solve a = b for b's variable
  Variable bx = b.var;
  while(bx instanceof jasymca.FunctionVariable){
   Algebraic arg = ((FunctionVariable)bx).arg;
   if( !(arg instanceof jasymca.Polynomial) ){
    throw new JasymcaException("Can not solve "+b+" for a variable.");
   }
   bx = ((Polynomial)arg).var;
  }
  Vektor sol = LambdaSOLVE.solve( a.sub(b), bx);

  Algebraic res[] = new Algebraic[sol.length()];
  for(int i=0; i<sol.length(); i++){
   Algebraic y = sol.get(i);
   res[i] = c.value(bx, y);
  }
  st.push( new Vektor(res).reduce() );
  return 0;
 }
}