package jasymca;

import java.util.Stack;

class LambdaSUM extends Lambda{
	// SUM (exp, ind, lo, hi)	
 public int lambda(Stack st) throws ParseException, JasymcaException{
  int narg = getNarg( st );
  if( narg == 1){ // Matlab Version: sum over Vector/Matrix
   Algebraic x = getAlgebraic( st );
   if( x.scalarq() && !x.constantq() )
    throw new JasymcaException("Unknown variable dimension: "+x);
   Matrix m = new Matrix(x);
   boolean addcols = (m.ncol() > 1);
   if( narg > 1 ){
    if( getInteger(st)==2 )
      addcols = false;
   }
   if( addcols ){
    Algebraic s = m.col(1);
    for(int i=2; i<=m.ncol(); i++)
     s = s.add(m.col(i));
    st.push( s );
   }else{
    Algebraic s = m.row(1);
    for(int i=2; i<=m.nrow(); i++)
     s = s.add(m.row(i));
    st.push( s );
   }
   return 0;
  }
  if(narg!=4)
   throw new ParseException("Usage: SUM (exp, ind, lo, hi)");
  Algebraic exp = getAlgebraic(st);
  Variable v = getVariable (st);
  int lo = getInteger (st);
  int hi = getInteger (st);
  Algebraic sum = Zahl.ZERO;
  for( ; lo <= hi; lo++)
   sum = sum.add(exp.value(v,new Unexakt((double)lo)));
  st.push( sum );
  return 0;
 }
}