package jasymca;

import org.netlib.util.*;

import org.netlib.lapack.DGESDD;
import org.netlib.lapack.DGEES;


/* Jasymca	-	- Symbolic Calculator for Mobile Devices
   This version is written for J2ME, CLDC 1.1,  MIDP 2, JSR 75
   or J2SE


   Copyright (C) 2006,2009 - Helmut Dersch  der@hs-furtwangen.de
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*------------------------------------------------------------*/

import java.util.*;



class LambdaSVD extends LambdaAlgebraic{
 public int lambda(Stack st) throws ParseException, JasymcaException{
  try{
   Class c = Class.forName("org.netlib.lapack.DGESDD");
  }catch(ClassNotFoundException ce){
   throw new JasymcaException("JLAPACK not available.");
  }
  int narg = getNarg( st );
  if(narg!=1)
   throw new JasymcaException("Usage: SVD( A ).");
  Matrix mx = new Matrix( getAlgebraic(st) );
  double a[][] = mx.getDouble();
  int m = mx.nrow(), n = mx.ncol();
  double[] s = new double[Math.min(m,n)];
  String jobz = "A";
  double u[][] = new double[m][m];
  double vt[][]= new double[n][n];
        int lwork = 3*Math.min(m,n)*Math.min(m,n) +
                       Math.max(Math.max(m,n),4*Math.min(m,n)*Math.min(m,n)
                       +4*Math.min(m,n));
  double work[] = new double[lwork];
  int iwork[] = new int[8*Math.min(m,n)];
  intW info = new intW(1);
  DGESDD.DGESDD( jobz, m, n, a,s,u,vt,work,lwork,iwork,info);
  if( info.val != 0 )
   throw new JasymcaException("jlapack DGESDD failed.");
  if(length==1){
      st.push((new Vektor(s)).reduce());
     }else if(length==3) {
      st.push((new Matrix(u)).reduce());
      st.push((new Vektor(s)).reduce());
      st.push((new Matrix(vt)).reduce());
      length = 1;
     }else
      throw new JasymcaException("Wrong number of output variables: "+length);
     return 0;
 }
}
