package jasymca;

import java.util.Stack;

class LambdaTAYLOR extends Lambda{
	// TAYLOR (exp, var, pt, pow)	
 public int lambda(Stack st) throws ParseException, JasymcaException{
  int narg = getNarg( st );
  if(narg!=4)
   throw new ParseException("Usage: TAYLOR (exp, var, pt, pow)");
  Algebraic exp = getAlgebraic(st);
  Variable v = getVariable(st);
  Algebraic pt = getAlgebraic(st);
  int n = getInteger(st);

  Algebraic r = exp.value(v, pt);
  Algebraic t = new Polynomial(v).sub(pt);
  double nf = 1.0;
  for(int i=1; i<=n; i++){
   exp = exp.deriv(v);
   nf *= i; // Fakultaet
   r = r.add(exp.value(v,pt).mult(t.pow_n(i)).div(new Unexakt(nf)));
  }
  st.push( r );
  return 0;
 }
}