package jasymca;

import jasymca.ErrorLogger;
import jasymca.JasymcaException;
import jasymca.Lambda;
import jasymca.Matrix;
import jasymca.ParseException;
import jasymca.Vektor;

import java.util.ArrayList;
import java.util.List;
import java.util.Stack;
import java.util.StringTokenizer;
import java.io.*;


class LambdaCSVREAD extends Lambda{
 public int lambda(Stack st) throws ParseException, JasymcaException{
  
	
  int narg = getNarg( st );
  if(narg != 1)
	   throw new JasymcaException("Usage: csvread(filename)");


 Object s_in = st.pop();
 if(!(s_in instanceof java.lang.String) )
         throw new JasymcaException("First argument to csvread must be string (filename).");
 String filename = (String)s_in;
 filename=filename.trim();
 
	 
 ErrorLogger.debugLine("Reading CSV>"+filename+"<");
// st.push(new Unexakt(2.));
 
 
 // st.push( new Matrix(10, 10).reduce() );
 
  File CSVFile = new File(filename);
  if(!CSVFile.exists()) {
	         throw new JasymcaException("File do not exists or the path is wrong"+filename);
  }
  
	
    List<Double> vec= new ArrayList<Double>();
    List<double[]> mat= new ArrayList<double[]>();
    boolean isVector=false;
    
	String strLine;
	int lineNumber=0;
	int colums=0;
	  //Read File Line By Line
	  try {
	 BufferedReader br = new BufferedReader( new FileReader(CSVFile));  
		while ((strLine = br.readLine()) != null)   {
		  // Print the content on the console
		  // System.out.println (strLine);
		  lineNumber++;
          
		  if (lineNumber==1) if (strLine.indexOf(",") ==-1) isVector=true;
		  if (isVector) {
			  double dd = Double.parseDouble(strLine);
			  vec.add(dd);
		  } else {
			  

			 StringTokenizer sst = new StringTokenizer(strLine, ",");
			 colums=sst.countTokens();
			 double[] row=new double[colums];
			 int nn=0;
			 while(sst.hasMoreTokens())
			  {
			     String val = sst.nextToken();
			     row[nn]=Double.parseDouble(val);
			     nn++;
			  }
			 mat.add(row);
		  }
		  } // end loop
		br.close();
		
	if (isVector) {
		double[] ret = new double[vec.size()];
		for (int i=0; i<vec.size(); i++) ret[i]=vec.get(i);
		st.push( new Vektor(ret) );
		return 0;
	} else { // matrix
		
		double[][] d= new double[mat.size()][colums];
		for (int i=0; i<mat.size(); i++) {
			double[] cols=(double[])mat.get(i);
			for (int j=0; j<cols.length; j++) {
			d[i][j]=cols[j];
		}}
		
		st.push( new Matrix(d) );
		return 0;
	}
		
		
		
	} catch (IOException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
	  
 
 return 0;
 }
}






/*
@GROUP
IO
@SYNTAX
csvread(filename)
@DOC
read matrix or vector "A" to a file with name "filename"
@EXAMPLES
<programlisting>
</programlisting>
@NOTES
@SEE csvwrite

*/
