package jasymca;

import jasymca.ErrorLogger;
import jasymca.JasymcaException;
import jasymca.Lambda;
import jasymca.Matrix;
import jasymca.ParseException;
import jasymca.Vektor;

import java.util.Stack;
import java.io.*;


class LambdaCSVWRITE extends Lambda{
 public int lambda(Stack st) throws ParseException, JasymcaException{
  int narg = getNarg( st );


  Object s_in = st.pop();
 if(!(s_in instanceof java.lang.String) )
         throw new JasymcaException("First argument to csvwrite must be string (filename).");
 String filename = (String)s_in;
 filename=filename.trim();
 
 ErrorLogger.debugLine("Writing CSV>"+filename+"<");

  Object n = st.pop();
  if(!(n instanceof jasymca.Matrix) && !(n instanceof jasymca.Vektor) )
         throw new JasymcaException("Second argument to csvwrite must be a Matrix or Vektor");

  
  // write vector
  if(n != null && n instanceof jasymca.Vektor){
	     Vektor mx = new Vektor( getAlgebraic(st) );
	     double values[] = mx.getDouble();

	     try {
             File CSVFile = new File(filename);
             BufferedWriter outWriter = new BufferedWriter( new FileWriter(CSVFile));
             try {                                
             for(int row = 0; row < values.length; row++) 
                outWriter.write( Double.toString(values[row])+"\n");  
             }
             catch(Exception e)
            {
            	 new JasymcaException("CSVWRITE cannot write vector to file:"+filename);       	  
                 ErrorLogger.debugLine("CSWRITE: function exception - " + e.getMessage());
             }
             outWriter.close();
             }
       catch(Exception e){
    	   new JasymcaException("CSVWRITE cannot write file:"+e.getMessage());       
            
             }
  return 0;
  }
  
  
  
  // now dealing with matrix     
  if(n != null && n instanceof jasymca.Matrix){
	     Matrix mx = new Matrix( getAlgebraic(st) );
	     double values[][] = mx.getDouble();
  
  try {
             File CSVFile = new File(filename);
             BufferedWriter outWriter = new BufferedWriter( new FileWriter(CSVFile));
             try {
                                                
             for(int row = 0; row < values.length; row++) {
                                                
             String line = "";
             for(int column = 0; column < values[row].length; column++){
             line = line + Double.toString(values[row][column]) + ",";
             }
             outWriter.write(line, 0, line.length() - 1);
             outWriter.newLine();
            }
             }
             catch(Exception e)
            {
            	 new JasymcaException("CSVWRITE cannot write file:"+filename);       	  
                 ErrorLogger.debugLine("CSVRead: load function exception - " + e.getMessage());
             }
             outWriter.close();
             }
       catch(Exception e){
    	   new JasymcaException("CSVWRITE cannot write file:"+e.getMessage());       
            
             }
  

  }




  return 0;
 }
}







/*
@GROUP
IO
@SYNTAX
csvwrite(filename,A)
@DOC
write matrix or vector "A" to a file with name "filename"
@EXAMPLES
<programlisting>
</programlisting>
@NOTES
@SEE csvread

*/
