package jasymca;

import jasymca.Jasymca;
import jasymca.JasymcaException;
import jasymca.Lambda;
import jasymca.ParseException;

import java.io.IOException;
import java.io.InputStream;
import java.util.List;
import java.util.Stack;

class LambdaLOADFILE extends Lambda{
//  LOADFILE (filename) 	
 public int lambda(Stack st) throws ParseException, JasymcaException{
  int narg = getNarg( st );
  if(narg!=1)
   throw new ParseException("Usage: LOADFILE (filename)");
  Object filename = st.pop();
  if(!(filename instanceof java.lang.String))
   throw new JasymcaException( filename+" not a valid filename.");
  try{
   readFile( (String)filename );
   // System.out.println( "Loaded Variables from "+filename);
       jmatmain.SetEnv.outputString= jmatmain.SetEnv.outputString+"Loaded Variables from "+filename;
  }catch(Exception e){
   throw new JasymcaException("Could not read from "+filename+" :"+e.toString());
  }
  return 0;
 }

  // search for file in path
 // read file and feed through evalloop
 public static void readFile( String fname )
    throws IOException, ParseException, JasymcaException{
  String sep="/";
  String s;
  Class c = (new LambdaLOADFILE()).getClass();

  for(int i=0; i<pc.env.path.size(); i++){
   String dir = (String)pc.env.path.elementAt(i);
   s = fname.startsWith( sep ) ? dir+fname : dir+sep+fname;
   InputStream f = c.getResourceAsStream(s);
   if( f == null ){
    try{
     f = Jasymca.getFileInputStream( s );
    }catch(Exception e){
     continue;
    }
   }
   if( f== null )
    continue;
   readFile( f );
   return;
  }
  throw new IOException("Could not open "+fname+".");
 }

 public static void readFile( InputStream f ) throws JasymcaException{
  Stack old_stack = pc.stack;
  pc.stack = new Stack();
  try{
   while(true){
    List code = pr.compile(f,null); // Convert to prefix notation
    if( code == null ) break; // EOF
    pc.process_list( code, true );
   }
   f.close();
   pc.stack = old_stack;
   return;
  }catch(Exception e){
   pc.stack = old_stack;
   throw new JasymcaException(e.toString());
  }
 }

}

/*
@GROUP
IO
@SYNTAX
loadfile("filename")
@DOC
Runs the M-script file specified by filename.
@NOTE
This is used to run script files, not function files.
@EXAMPLES
<programlisting>
loadfile("script.m");
</programlisting>
@SEE
*/

