package jasymca;

import jasymca.JasymcaException;
import jasymca.Lambda;
import jasymca.ParseException;

import java.util.Stack;



class LambdaPRINTF extends Lambda{
	 public int lambda(Stack st) throws ParseException, JasymcaException{
	  printf( st );
	  return 0;
	 }

	 static void printf( Stack st )throws ParseException, JasymcaException{

	  int narg = getNarg( st );
	  Object s_in = st.pop();
	  if(!(s_in instanceof java.lang.String) )
	   throw new JasymcaException("Argument to PRINTF must be string.");
	  String fmt = (String)s_in;
	  int idx, i=1;
	  String cs = "%f";

	  while( (idx = fmt.indexOf( cs )) != -1 && !st.empty() && narg-- > 1) {
	   Object n = st.pop();
	   if(n != null){
	    StringBuffer sb = new StringBuffer( fmt );
	    sb.delete( idx, idx+cs.length() );
	    sb.insert( idx, n.toString() );
	    fmt = sb.toString();
	   }else
	    break;
	  }

	  while( (idx = fmt.indexOf( "\\n" )) != -1 ) {
	   StringBuffer sb = new StringBuffer( fmt );
	   sb.delete( idx, idx+"\\n".length() );
	   sb.insert( idx, "\n" );
	   fmt = sb.toString();
	  }

	  if(pc.ps != null){
	   pc.ps.print( fmt.toString() ); // chekanov 
	   // jmatmain.SetEnv.outputString=jmatmain.SetEnv.outputString+fmt.toString(); // chekanov
	  }
	 }
	}


/*
@GROUP
char
@SYNTAX
printf( formatString, arg0, arg1, arg2, ... )
@DOC
Convert values to string and print them. The values can be numbers, vectors, matrices.
@EXAMPLES
printf('Number=%f',10)
@NOTES
.
@SEE
*/
