package jasymca;

import jasymca.ErrorLogger;
import jasymca.JasymcaException;
import jasymca.Lambda;
import jasymca.Matrix;
import jasymca.ParseException;
import jasymca.Vektor;

import java.util.Stack;
import java.io.*;
import java.net.*;

class LambdaURLREAD extends Lambda{


   public int lambda(Stack st) throws ParseException, JasymcaException{
          urlread( st );
          return 0;
         }

 static void urlread( Stack st )throws ParseException, JasymcaException{

 int narg = getNarg( st );

 Object s_in = st.pop();
 if(!(s_in instanceof java.lang.String) )
         throw new JasymcaException("First argument to csvwrite must be string (filename).");
 String filename = (String)s_in;
 filename=filename.trim();
 ErrorLogger.debugLine("Read URL>"+filename+"<");

  
 // open URL
        String s="";
        String lineFile;

        URL url = null;
        try
        {
            url = new URL( filename );
        }
        catch (Exception e)
        {
            throw new JasymcaException("urlread: malformed url");
        }

          // read file over the network
        try
            {
                    BufferedReader inReader =
                new BufferedReader(new InputStreamReader( url.openStream() ));

            while ((lineFile = inReader.readLine()) != null)
                    {
                        s += lineFile + "\n";
                    }

                    inReader.close();
             }
             catch (Exception e)
             {
                    new JasymcaException("urlread: error input stream");
             }


          st.push( " "+s );

 }
}






/*
@GROUP
input_output
@SYNTAX
urlread( URL)
@DOC
Read a text file from the network. This function supports many
transfer protocols e.g. http, gopher, ftp, file. 
It returns a string with the file.
@EXAMPLE
<programlisting>
txt=urlread("http://www.jwork/data.csv");
</programlisting>
@NOTES
.
@SEE
csvread, csvwrite
*/
