package jasymca;

import jasymca.JasymcaException;
import jasymca.Lambda;
import jasymca.Matrix;
import jasymca.ParseException;

import java.util.Stack;



/**An external function for computing eigenvalues and eigenvectors of an array  */
class LambdaEIG extends Lambda{
 public int lambda(Stack st) throws ParseException, JasymcaException{
  int narg = getNarg( st );
  Matrix m = new Matrix(getAlgebraic( st ));
  st.push( m.eigenvalues());
  return 0;
 }
}


/*
@GROUP
matrix
@SYNTAX
eig(matrix)
@DOC
Caculates the eigenvalues of the matrix.
@NOTES
@EXAMPLES
<programlisting>
eig([1,2;3,4])=[-0.372;5.372]
</programlisting>
@SEE
*/
