package jasymca;

import jasymca.JasymcaException;
import jasymca.LambdaAlgebraic;
import jasymca.Matrix;
import jasymca.ParseException;
import jasymca.Vektor;

import java.util.Stack;

import org.netlib.lapack.DGEEV;
import org.netlib.util.intW;

/*
class LambdaSCHUR extends LambdaAlgebraic{
	public int lambda(Stack st) throws ParseException, JasymcaException{ 
		try{
			Class c = Class.forName("org.netlib.lapack.DGEES");
		}catch(ClassNotFoundException ce){
			throw new JasymcaException("JLAPACK not available.");
		}
		int narg = getNarg( st );
		if(narg!=1)
			throw new JasymcaException("Usage: SCHUR( A ).");
		Matrix mx     = new Matrix( getAlgebraic(st) );
		double a[][]  = mx.getDouble();
		int n         = mx.ncol();
		if(mx.nrow() != n)
			throw new JasymcaException("Matrix must be square.");
		String jobvs  = "V";
		String sort   = "N";
		Object select = null;
		intW  sdim    = new intW(1);
		double wr[]   = new double[n];
		double wi[]   = new double[n];
		double vs[][] = new double[n][n];
		double[] work = new double[1];
		int lwork     = -1;
		boolean bwork[] = null;
		intW  info    = new intW(1);
		// query call
		DGEES.DGEES( jobvs, sort,null,n,a,sdim,wr,wi,vs,work,lwork,bwork,info);
		lwork = (int)work[0];
		if( lwork <= 0 )
			throw new JasymcaException("jlapack DGEES query failed.");
		// set up work area
		work = new double[lwork];
		DGEES.DGEES( jobvs, sort,null,n,a,sdim,wr,wi,vs,work,lwork,bwork,info);
		if( info.val != 0 )
			throw new JasymcaException("jlapack DGEES failed.");
//		System.out.println("Rank R11:"+rank.val);
		st.push( new Matrix(a).reduce() );
		return 0;
	}
}
*/
class LambdaEIGEN extends LambdaAlgebraic{
 public int lambda(Stack st) throws ParseException, JasymcaException{
  try{
   Class c = Class.forName("org.netlib.lapack.DGEEV");
  }catch(ClassNotFoundException ce){
   throw new JasymcaException("JLAPACK not available.");
  }
  int narg = getNarg( st );
  if(narg!=1)
   throw new JasymcaException("Usage: Eigen( A ).");
  Matrix mx = new Matrix( getAlgebraic(st) );
  double a[][] = mx.getDouble();
  int n = mx.ncol();
  if(mx.nrow() != n)
   throw new JasymcaException("Matrix must be square.");
  String jobvl = "V";
  String jobvr = "V";
  Object select = null;
  intW sdim = new intW(1);
  double wr[] = new double[n];
  double wi[] = new double[n];
  double vl[][] = new double[n][n];
  double vr[][] = new double[n][n];
  double[] work = new double[1];
  int lwork = -1;
  intW info = new intW(1);
  // query call
  DGEEV.DGEEV(jobvl,jobvr,n,a,wr,wi,vl,vr,work,lwork,info);
        lwork = (int)work[0];
  if( lwork <= 0 )
   throw new JasymcaException("jlapack DGEEV query failed.");
  // set up work area
  work = new double[lwork];
  DGEEV.DGEEV(jobvl,jobvr,n,a,wr,wi,vl,vr,work,lwork,info);
  if( info.val != 0 )
   throw new JasymcaException("jlapack DGEEV failed.");
//		System.out.println("Rank R11:"+rank.val);
  st.push( new Vektor(wr,wi).reduce() );
  return 0;
 }
}



/*
@GROUP
matrix
@SYNTAX
eigen(matrix)
@DOC
Calculates the eigenvalues of the matrix.
@NOTES
@EXAMPLES
<programlisting>
eigen([1,2;3,4])=[-0.372;5.372]
</programlisting>
@SEE
*/
