package jasymca;

import jasymca.Algebraic;
import jasymca.Exakt;
import jasymca.JasymcaException;
import jasymca.Lambda;
import jasymca.Matrix;
import jasymca.ParseException;

import java.util.Stack;

class LambdaHILB extends Lambda{
 public int lambda(Stack st) throws ParseException, JasymcaException{
  int narg = getNarg( st );
  int n = getInteger( st );
  Algebraic a[][] = new Algebraic[n][n];
  for(int i=0; i<n; i++)
   for(int k=0; k<n; k++)
    a[i][k] = new Exakt(1L, (long)(i+k+1));
  st.push( new Matrix( a ));
  return 0;
 }
}


/*
@GROUP
specialmatrix
@SYNTAX
answer = template (value)
@DOC
Return the Hilbert matrix of order n. Expecting scalar argument
@EXAMPLES
@NOTES
@SEE
rosser
*/
