package jasymca;

import jasymca.JasymcaException;
import jasymca.Lambda;
import jasymca.Matrix;
import jasymca.ParseException;

import java.util.Stack;

class LambdaINV extends Lambda{
 public int lambda(Stack st) throws ParseException, JasymcaException{
  int narg = getNarg( st );
  Matrix m = new Matrix(getAlgebraic( st ));
  st.push( m.invert() );
  return 0;
 }
}


/*
@GROUP
matrix
@SYNTAX
answer=INV(square matrix)
@DOC
Returns the inverse of the first operand, which must be a square matrix.
@NOTES
@EXAMPLES
INV([1,0;0,1]) = [1,0;0,1]
@SEE
*/
