package jasymca;

import jasymca.Algebraic;
import jasymca.JasymcaException;
import jasymca.Lambda;
import jasymca.Matrix;
import jasymca.ParseException;
import jasymca.Vektor;

import java.util.Stack;

class LambdaMATRIX extends Lambda{
 public int lambda(Stack st) throws ParseException, JasymcaException{
  int narg = getNarg( st );
  Algebraic[][]a = new Algebraic[narg][];
  for(int i=0; i<narg; i++){
   Algebraic b = getAlgebraic(st);
   if( b instanceof jasymca.Vektor )
    a[i] = ((Vektor)b).get();
   else{
    a[i] = new Algebraic[1];
    a[i][0] = b;
   }
   if( a[i].length != a[0].length )
    throw new JasymcaException(
     "Matrix rows must have equal length.");
  }
  st.push( new Matrix(a).reduce() );
  return 0;
 }
}