package jasymca;

import jasymca.ExpandConstants;
import jasymca.JasymcaException;
import jasymca.Lambda;
import jasymca.ParseException;
import jasymca.PlotGraph;
import jasymca.Vektor;
import jhplot.*;
import jmathlab.utils.UtilsOptions;

import java.awt.Color;
import java.util.ArrayList;
import java.util.Stack;

class LambdaDRAW2D extends Lambda {

	public int lambda(Stack st) throws ParseException, JasymcaException {
		return drawArgs2D(st);
	}

	int drawArgs2D(Stack st) throws ParseException,
			JasymcaException {

  //              System.out.println("Draw 1");


		if (LambdaPLOT2D.pg == null) {
                             return 0; 
		} 

 //               System.out.println("Draw 2");

		int narg = getNarg(st);
		Object pargs[] = new Object[narg];
                String option="";

		for (int i = 0; i < narg; i++) {
			Object x = st.pop();
			if (x instanceof jasymca.Vektor) {
				x = new ExpandConstants().f_exakt((Vektor) x);
				pargs[i] = ((Vektor) x).getDouble();
			} else
				pargs[i] = x;
                        if (x instanceof java.lang.String) { 
                            option=(pargs[i].toString()).trim();
                         }

		}


                //  System.out.println("1) Option is="+option);
                  P1D p1=null;

                   if (pargs.length>1){
                      double x[] = (double[])  pargs[0];
                      double y[] = (double[])   pargs[1];
                       if (x.length != y.length)
                                        throw new JasymcaException("X and Y must be same length");
                       p1 = new P1D("data",x,y);

                   }

/*
                        for (int i = 0; i < pargs.length;) {
                        if (i < pargs.length - 1
                                        && !(pargs[i + 1] instanceof java.lang.String)) {
                                double x[] = (double[])  pargs[i];
                                double y[] = (double[])   pargs[i + 1];
                                if (x.length != y.length)
                                        throw new JasymcaException("X and Y must be same length");
                                p1 = new P1D("data",x,y);
                                i += 2;
                        } else {
                                double x[] = (double[])pargs[i];
                                double y[] = new double[x.length];
                                for (int ind = 0; ind < x.length; ind++)
                                        y[ind] = ind + 1;
                                p1 = new P1D("data",y,x);
                                i++;
                        }

                  }
*/

               if (p1==null) return 0;

               if (option.length()>0) { 
              //  System.out.println("2) Option is="+option);            
               UtilsOptions uo = new UtilsOptions(option);
               p1.setTitle(uo.getStringValue("name", "data"));
               p1.setStyle(uo.getStringValue("style", "p"));
               p1.setSymbol(uo.getIntValue("symboltype", 4));
               p1.setPenWidth(uo.getIntValue("linewidth", 2));
               p1.setLineStyle(uo.getIntValue("linestyle", 1));
               p1.setSymbolSize(uo.getIntValue("symbolsize", 4));
               p1.setColor(uo.getColorValue("symbolcolor",Color.black));
               
               }

              
 
               LambdaPLOT2D.pg.draw(p1);



		return 0;
	}
}

/*
@GROUP
plot
@SYNTAX
draw2d(x,y [option])
@DOC
Draw data using 2D plots. 
@NOTES
@EXAMPLES
x=0:0.1:10; y=sin(x)
draw2d(x,y,"style=lp,linewidth=1")
@SEE
plot2d
*/

