package jasymca;

import jasymca.ExpandConstants;
import jasymca.JasymcaException;
import jasymca.Lambda;
import jasymca.ParseException;
import jasymca.PlotGraph;
import jasymca.Vektor;
import jhplot.*;
import jmathlab.utils.UtilsOptions;

import java.awt.Color;
import java.util.ArrayList;
import java.util.Stack;

class LambdaDRAW3D extends Lambda {

	public int lambda(Stack st) throws ParseException, JasymcaException {
		return drawArgs3D(st);
	}

	int drawArgs3D(Stack st) throws ParseException,
			JasymcaException {

  //              System.out.println("Draw 1");


		if (LambdaPLOT3D.pg == null) {
                             return 0; 
		} 

 //               System.out.println("Draw 2");

		int narg = getNarg(st);
		Object pargs[] = new Object[narg];
                String option="";

		for (int i = 0; i < narg; i++) {
			Object x = st.pop();
			if (x instanceof jasymca.Vektor) {
				x = new ExpandConstants().f_exakt((Vektor) x);
				pargs[i] = ((Vektor) x).getDouble();
			} else
				pargs[i] = x;
                        if (x instanceof java.lang.String) { 
                            option=(pargs[i].toString()).trim();
                         }

		}


                //  System.out.println("1) Option is="+option);
                  P2D p1=null;

                   if (pargs.length==1 && option.length()>1){
                       F2D f1 = new F2D(option);
                       LambdaPLOT3D.pg.draw(f1);
                       return 0;
                    }
 

                   if (pargs.length>2){
                      double x[] = (double[])pargs[0];
                      double y[] = (double[])pargs[1];
                      double z[] = (double[])pargs[2];

                       if (x.length != y.length || x.length != z.length)
                                        throw new JasymcaException("X,Y,Z must be same length");
                       p1 = new P2D("data");
                       p1.setSymbolColor(Color.blue);

                       for (int j=x.length-1; j>0; j--){
                         //System.out.println(x[j]);
                         //System.out.println(y[j]);
                         //System.out.println(z[j]);
                         p1.add(x[j],y[j],z[j]);
                       }

                   }

/*
                        for (int i = 0; i < pargs.length;) {
                        if (i < pargs.length - 1
                                        && !(pargs[i + 1] instanceof java.lang.String)) {
                                double x[] = (double[])  pargs[i];
                                double y[] = (double[])   pargs[i + 1];
                                if (x.length != y.length)
                                        throw new JasymcaException("X and Y must be same length");
                                p1 = new P1D("data",x,y);
                                i += 2;
                        } else {
                                double x[] = (double[])pargs[i];
                                double y[] = new double[x.length];
                                for (int ind = 0; ind < x.length; ind++)
                                        y[ind] = ind + 1;
                                p1 = new P1D("data",y,x);
                                i++;
                        }

                  }
*/

               if (p1==null) return 0;

               if (option.length()>0) { 
              //  System.out.println("2) Option is="+option);            
               UtilsOptions uo = new UtilsOptions(option);
               p1.setTitle(uo.getStringValue("name", "data"));
              // p1.setStyle(uo.getStringValue("style", "p"));
              // p1.setSymbol(uo.getIntValue("symboltype", 4));
              // p1.setPenWidth(uo.getIntValue("linewidth", 2));
              // p1.setLineStyle(uo.getIntValue("linestyle", 1));
               p1.setSymbolSize(uo.getIntValue("symbolsize", 4));
               p1.setSymbolColor(uo.getColorValue("symbolcolor",Color.blue));
               
               }
            
               /* 
               P2D h2=new P2D("data"); 
               h2.add(3,2,3);
               h2.add(2,3, 8);
               h2.add(1,-1, 3);
               */

               // System.out.println(p1.toString()); 
               LambdaPLOT3D.pg.draw(p1);



		return 0;
	}
}

/*
@GROUP
plot
@SYNTAX
draw3d(x,y,z [option])
or
draw3d(f(x,y))

@DOC
Draw data using 3D plots or 3D functions. 
Function should have two variables, x and y.
@NOTES
@EXAMPLES
x=0:0.1:10; y=sin(x); z=cos(x); 
draw3d(x,y,z"style=lp,linewidth=1")
@SEE
plot3d
*/

