package jasymca;

import jasymca.ExpandConstants;
import jasymca.JasymcaException;
import jasymca.Lambda;
import jasymca.ParseException;
import jasymca.PlotGraph;
import jasymca.Vektor;

import java.util.Stack;

// gcc -x c -P -E PlotGraph.java -o src/symbjava/PlotGraph.java
class LambdaPLOT extends Lambda {
	static PlotGraph pg = null;

	public int lambda(Stack st) throws ParseException, JasymcaException {
		return plotArgs(PlotGraph.LINEAR, st);
	}

	int plotArgs(int plotmode, Stack st) throws ParseException,
			JasymcaException {
		if (pg == null) {
			pg = new PlotGraph(plotmode);
		} else
			pg.setmode(plotmode);
		int narg = getNarg(st);
		Object pargs[] = new Object[narg];
		for (int i = 0; i < narg; i++) {
			Object x = st.pop();
			if (x instanceof jasymca.Vektor) {
				x = new ExpandConstants().f_exakt((Vektor) x);
				pargs[i] = ((Vektor) x).getDouble();
			} else
				pargs[i] = x;
		}
		pg.addLine(pargs);
		pg.setVisible(true);
		return 0;
	}
}



/*
@GROUP
plot
@SYNTAX
plot(x,y [option])  
option x and y are equalized vectors. option is a string, specifying color (one of r,g,b,y,m,c,w,k) and symbol (one of +,*,o,x).
@DOC
plot data
@NOTES
@EXAMPLES
x=0:0.1:10; y=sin(x)
plot(x,y)
@SEE
*/


