package jasymca;

import jasymca.ExpandConstants;
import jasymca.JasymcaException;
import jasymca.Lambda;
import jasymca.ParseException;
import jasymca.PlotGraph;
import jasymca.Vektor;
import jhplot.*;
import java.util.Stack;
import jmathlab.utils.UtilsOptions;


class LambdaPLOT2D extends Lambda {
	static  HPlot  pg = null;

	public int lambda(Stack st) throws ParseException, JasymcaException {
		return plotArgs2D(st);
	}

	int plotArgs2D(Stack st) throws ParseException,
			JasymcaException {

                if (pg != null) pg = null;
 
                
		if (pg == null) {
                       // System.out.println("HPlot created");
			pg = new HPlot("HPlot2D",600,400,1,1);
                        pg.visible(true);
                        pg.setAutoRange(true); 
		} 

              int narg = getNarg(st);
              String options[] = new String[narg];
               int ntot=0;
               for (int i = 0; i < narg; i++) {
                 Object s_in = st.pop();
                 if (s_in instanceof java.lang.String) {
                        options[i]=s_in.toString();
                        ntot++;
               }
              }


              if (ntot>0){
               if (options[0].length()>0) {
               UtilsOptions uo = new UtilsOptions(options[0]);

              if (options[0].indexOf("log")>-1){
               pg.setLogScale(0,uo.getBooleanValue("logx", false));
               pg.setLogScale(1,uo.getBooleanValue("logy", false));
               }
               pg.setGTitle(uo.getStringValue("title",""));
               pg.setNameX(uo.getStringValue("titlex","X"));
               pg.setNameY(uo.getStringValue("titley","Y"));

              if (options[0].indexOf("min")>-1 || options[0].indexOf("max")>-1) {
               double xmin=uo.getDoubleValue("minx",-1);
               double  xmax=uo.getDoubleValue("maxx",1);
               double ymin=uo.getDoubleValue("miny",-1);
               double  ymax=uo.getDoubleValue("maxy",1);
               pg.setRange(xmin,xmax,ymin,ymax); 
              } 
             }
            }


	      return 0;
	}
}

/*
@GROUP
plot2d 
@SYNTAX
plot2d([option])  
Prepare an empty plot for drawing
@DOC
plot data
@NOTES
@EXAMPLES
plot2d()
@SEE
*/

