package jasymca;

import jasymca.ExpandConstants;
import jasymca.JasymcaException;
import jasymca.Lambda;
import jasymca.ParseException;
import jasymca.PlotGraph;
import jasymca.Vektor;
import jhplot.*;
import java.util.Stack;
import jmathlab.utils.UtilsOptions;


class LambdaPLOT3D extends Lambda {
	static  HPlot3D  pg = null;

	public int lambda(Stack st) throws ParseException, JasymcaException {
		return plotArgs3D(st);
	}

	int plotArgs3D(Stack st) throws ParseException,
			JasymcaException {

              int narg = getNarg(st);
              String options[] = new String[narg];
               int ntot=0;
               for (int i = 0; i < narg; i++) {
                 Object s_in = st.pop();
                 if (s_in instanceof java.lang.String) {
                        options[i]=s_in.toString();
                        ntot++;
               }
              }


              if (pg != null) pg = null;


                if (pg == null) {
                       // System.out.println("HPlot created");
                        pg = new HPlot3D("HPlot3D",500,500);
                        pg.setAutoRange();
                }

              pg.setAutoRange(true);

              if (ntot>0){
               if (options[0].length()>0) {
               UtilsOptions uo = new UtilsOptions(options[0]);

              //if (options[0].indexOf("log")>-1){
              // pg.setLogScale(0,uo.getBooleanValue("logx", false));
              // pg.setLogScale(1,uo.getBooleanValue("logy", false));
              // }
               pg.setGTitle(uo.getStringValue("title",""));
               pg.setNameX(uo.getStringValue("titlex","X"));
               pg.setNameY(uo.getStringValue("titley","Y"));
               pg.setNameZ(uo.getStringValue("titlez","Z"));

              if (options[0].indexOf("min")>-1 || options[0].indexOf("max")>-1) {
               double xmin=uo.getDoubleValue("minx",-1);
               double  xmax=uo.getDoubleValue("maxx",1);
               double ymin=uo.getDoubleValue("miny",-1);
               double  ymax=uo.getDoubleValue("maxy",1);
               double zmin=uo.getDoubleValue("minz",-1);
               double  zmax=uo.getDoubleValue("maxz",1);
               pg.setRange(xmin,xmax,ymin,ymax,zmin,zmax); 
              } 
             }
            }


              pg.visible(true);
	      return 0;
	}
}

/*
@GROUP
plot3d 
@SYNTAX
plot3d([option])  
Prepare an empty plot for drawing in 3D 
@DOC
plot data in 3D 
@NOTES
@EXAMPLES
plot3d()
@SEE
*/

