package jasymca;

import jasymca.JasymcaException;
import jasymca.Lambda;
import jasymca.ParseException;

import java.io.FileOutputStream;
import java.util.Stack;

import net.sf.epsgraphics.ColorMode;
import net.sf.epsgraphics.EpsGraphics;

class LambdaPRINT extends Lambda {
	public int lambda(Stack st) throws ParseException, JasymcaException {
		try {
			Class c = Class.forName("net.sf.epsgraphics.EpsGraphics");
		} catch (ClassNotFoundException ce) {
			throw new JasymcaException("EpsGraphics-printer not available.");
		}
		int narg = getNarg(st);
		Object arg = st.pop();
		if (!(arg instanceof java.lang.String))
			throw new JasymcaException("Argument must be string.");
		if (LambdaPLOT.pg == null) {
			if (pc.ps != null) {
				pc.ps.println("Nothing to plot.");
			}
			return 0;
		}
		try {
			String fname = (String) arg;
			if (fname.charAt(0) == ' ')
				fname = fname.substring(1);
			FileOutputStream f = new FileOutputStream(fname);
			EpsGraphics eps = new EpsGraphics(fname, f, 0, 0,
					LambdaPLOT.pg.getWidth(), LambdaPLOT.pg.getHeight(),
					ColorMode.COLOR_RGB);
			LambdaPLOT.pg.drawGraph(eps);
			eps.close();
			if (pc.ps != null) {
				pc.ps.println("Wrote " + fname);
			}
		} catch (java.io.IOException e) {
			throw new JasymcaException(e.toString());
		}
		return 0;
	}
}