package jasymca;

import jasymca.Algebraic;
import jasymca.JasymcaException;
import jasymca.Lambda;
import jasymca.ParseException;
import jasymca.Polynomial;
import jasymca.SimpleVariable;
import jasymca.Vektor;

import java.util.Stack;
import java.util.Vector;

// Find roots of univariate real polynomial
class LambdaALLROOTS extends Lambda{

 public int lambda(Stack st) throws ParseException, JasymcaException{
  int narg = getNarg( st );
  Algebraic x = getAlgebraic( st ); // Evaluate to canonical form
  // Matlab version
  if( x instanceof jasymca.Vektor )
   x = new Polynomial(new SimpleVariable("x"), (Vektor)x);

  if(!(x instanceof jasymca.Polynomial))
   throw new JasymcaException("Argument to allroots must be polynomial.");
  Polynomial p = (Polynomial)((Polynomial)x).rat();
  Algebraic ps[] = p.square_free_dec(p.var);
  Vektor r;
  Vector v = new Vector();
  for(int i=0; i<ps.length; i++){
   if(ps[i] instanceof jasymca.Polynomial){
    r= ((Polynomial)ps[i]).monic().roots();
    for(int k=0; r != null && k<r.length() ; k++){
     for(int j=0; j<=i; j++)
      v.addElement(r.get(k));
    }
   }
  }
  st.push( Vektor.create(v) );
  return 0;
 }
}


/*
@GROUP
polynomial
@SYNTAX
y = allroots (x)
@DOC
Find all roots of univariate real polynomial
@NOTES
@EXAMPLES
@SEE
*/
