package jasymca;


import java.util.Stack;



import jasymca.*;
import jhplot.math.num.random.BetaRandomVariable;

class LambdaBETA_RND extends  Lambda{
	 public int lambda(Stack st) throws ParseException, JasymcaException{
		  int narg = getNarg( st );
		  if(narg!=3 && narg!=4)
		   throw new ParseException("requires 3 or 4 arguments. Mean, STD, dimension X and Y");
	 
		  if (narg==4 ){
		  Algebraic a = getAlgebraic( st );
		  Algebraic b = getAlgebraic( st );
		  Algebraic x = getAlgebraic( st );
		  Algebraic y = getAlgebraic( st );
		    
		  // generate matrix 
		  if(a instanceof jasymca.Zahl && 
		     b instanceof jasymca.Zahl &&
		     x instanceof jasymca.Zahl && 
		     y instanceof jasymca.Zahl ) {
			  
			  double x1= ((Zahl)a).unexakt().real;
			  double x2= ((Zahl)b).unexakt().real;
			  int j1= (int)((Zahl)x).unexakt().real;
			  int j2= (int)((Zahl)y).unexakt().real;
			  
			  BetaRandomVariable p =new BetaRandomVariable(x1,x2);
			   
			   double[][] d = new double[j1][j2];
			   for (int i=0; i<j1; i++){
				   for (int j=0; j<j2; j++){
					   d[i][j] = p.nextRandomVariable();
				   }
			   }
			   Matrix m = new Matrix(d);
			   st.push(m);
		    }
		  } 
		  
		  if (narg==3 ){
			  Algebraic a = getAlgebraic( st );
			  Algebraic b = getAlgebraic( st );
			  Algebraic x = getAlgebraic( st );
			    
			  // generate matrix 
			  if(a instanceof jasymca.Zahl &&  
			     b instanceof jasymca.Zahl &&
			     x instanceof jasymca.Zahl ) {
				  
				  double x1= ((Zahl)a).unexakt().real;
				  double x2= ((Zahl)b).unexakt().real;
				  int j1= (int)((Zahl)x).unexakt().real;
				  
				  BetaRandomVariable p =new BetaRandomVariable(x1,x2);
				  
				   
				   double[] d = new double[j1];
				   for (int i=0; i<j1; i++){
						   d[i] = p.nextRandomVariable();
					   
				   }
				   Vektor m = new Vektor(d);
				   st.push(m);
			    }
			  } 
		  
		  
		        
		  
		  return 0;
 }

}

/*
@GROUP
normal
@SYNTAX
beta_rnd(alpha, beta,x, y)
@DOC
The Beta distribution with the mean.
If x,y are given , create a matrix with Beta values with the dimension x (rows) and y (columns).
If only x is given, create a vector with Beta values of size "x" 
@EXAMPLES
<programlisting>
beta_rnd(1,0.2, 100) % creates a vector with size 100. alpha=1 and beta=2
beta_rnd(2,0.2, 50,60) % filled  50x60 matrix.
</programlisting>
@NOTES
@SEE
poisson
*/
