package jasymca;


import java.util.Stack;



import jasymca.*;
import jhplot.math.num.random.PoissonRandomVariable;

class LambdaPOISSON_RND extends  Lambda{
	 public int lambda(Stack st) throws ParseException, JasymcaException{
		  int narg = getNarg( st );
		  if(narg!=3 && narg!=2)
		   throw new ParseException("requires 2 or 3 arguments. Mean, dimension X and Y");
	 
		  if (narg==3 ){
		  Algebraic a = getAlgebraic( st );
		  Algebraic x = getAlgebraic( st );
		  Algebraic y = getAlgebraic( st );
		    
		  // generate matrix 
		  if(a instanceof jasymca.Zahl && 
		     x instanceof jasymca.Zahl && 
		      y instanceof jasymca.Zahl ) {
			  
			  double x1= ((Zahl)a).unexakt().real;
			  int j1= (int)((Zahl)x).unexakt().real;
			  int j2= (int)((Zahl)y).unexakt().real;
			  
			  PoissonRandomVariable p =new PoissonRandomVariable(x1);
			   
			   double[][] d = new double[j1][j2];
			   for (int i=0; i<j1; i++){
				   for (int j=0; j<j2; j++){
					   d[i][j] = p.nextRandomVariable();
				   }
			   }
			   Matrix m = new Matrix(d);
			   st.push(m);
		    }
		  } 
		  
		  if (narg==2 ){
			  Algebraic a = getAlgebraic( st );
			  Algebraic x = getAlgebraic( st );
			    
			  // generate matrix 
			  if(a instanceof jasymca.Zahl && 
			     x instanceof jasymca.Zahl ) {
				  
				  double x1= ((Zahl)a).unexakt().real;
				  int j1= (int)((Zahl)x).unexakt().real;
				  
				  PoissonRandomVariable p =new PoissonRandomVariable(x1);
				   
				   double[] d = new double[j1];
				   for (int i=0; i<j1; i++){
						   d[i] = p.nextRandomVariable();
					   
				   }
				   Vektor m = new Vektor(d);
				   st.push(m);
			    }
			  } 
		  
		  
		        
		  
		  return 0;
 }

}

/*
@GROUP
random
@SYNTAX
poisson_rnd(mean, x, y)
@DOC
The Poisson distribution with the mean.
If x,y are given , create a matrix with Poisson values with the dimension x (rows) and y (columns).
If only x is given, create a vector with Poisson values of size "x" 
@EXAMPLES
<programlisting>
poisson_rnd(1,100) % creates a vector with size 100. Poisson has the mean 1
poisson_rnd(2,50,60) % Poisson mean is 2, matrix 50x60 will be filled.
</programlisting>
@NOTES
@SEE
beta
*/
