package jasymca;

import jasymca.JasymcaException;
import jasymca.LambdaAlgebraic;
import jasymca.Sfun;
import jasymca.Unexakt;
import jasymca.Zahl;

class LambdaERF extends LambdaAlgebraic{
 public Zahl f(Zahl x) throws JasymcaException{
  return new Unexakt( Sfun.erf( x.unexakt().real ) );
 }
}

/*
@GROUP
special_functions
@SYNTAX
erf(x)
@DOC
Returns the error function erf(x)
See: http://mathworld.wolfram.com/Erf.html
@EXAMPLES
<programlisting>
erf(3.5)
</programlisting>
@NOTES
@SEE
beta
*/
