package jasymca;

import jasymca.JasymcaException;
import jasymca.LambdaAlgebraic;
import jasymca.Sfun;
import jasymca.Unexakt;
import jasymca.Zahl;

class LambdaGAMMA extends LambdaAlgebraic{
 public Zahl f(Zahl x) throws JasymcaException{
  return new Unexakt( Sfun.gamma( x.unexakt().real ) );
 }
}

/*
@GROUP
specfun
@SYNTAX
gamma(x)
@DOC
return gamma function
@EXAMPLES
<programlisting>
gamma(3.5)
gamma([2,3,4;5,6,7])
</programlisting>
@NOTES
@SEE
beta
*/
