package jasymca;

import jasymca.JasymcaException;
import jasymca.LambdaAlgebraic;
import jasymca.Sfun;
import jasymca.Unexakt;
import jasymca.Zahl;

class LambdaGAMMALN extends LambdaAlgebraic{
 public Zahl f(Zahl x) throws JasymcaException{
  return new Unexakt( Sfun.logGamma( x.unexakt().real ) );
 }
}


/*
@GROUP
special_functions
@SYNTAX
gammaln(x)
@DOC
return the log of the gamma function
@EXAMPLES
<programlisting>
gammaln(3.5)
gammaln([2,3,4;5,6,7])
</programlisting>
@NOTES
@SEE
beta
*/
