package jasymca;

import jasymca.JasymcaException;
import jasymca.LambdaAlgebraic;
import jasymca.Sfun;
import jasymca.Unexakt;
import jasymca.Zahl;
import jhplot.math.num.special.Erf;

class LambdaINVVERF extends LambdaAlgebraic{
 public Zahl f(Zahl x) throws JasymcaException{
  return new Unexakt( Erf.inverseErf( x.unexakt().real ) );
 }
}

/*
@GROUP
special_functions
@SYNTAX
inverf(x)
@DOC
Returns the inverse error function erf<sup>-1</sup>(y).
See: http://mathworld.wolfram.com/Erf.html
@EXAMPLES
<programlisting>
inverf(3.5)
</programlisting>
@NOTES
@SEE
beta
*/
