package jasymca;

import jasymca.*;


import java.util.Stack;
import java.io.*;

import jhplot.stat.Statistics;


class LambdaMEAN extends Lambda{
 public int lambda(Stack st) throws ParseException, JasymcaException{
  int narg = getNarg( st );

  Algebraic b_in= getAlgebraic(st);

  if(!(b_in instanceof jasymca.Matrix) && !(b_in instanceof jasymca.Vektor) )
         throw new JasymcaException("Must be a Matrix or Vector");

  if(b_in != null && b_in instanceof jasymca.Vektor){
             Vektor mx = new Vektor(  b_in );
             double values[] = mx.getDouble();
             double m= Statistics.mean(values);
             st.push( new Unexakt((double)m)  );
  }

  // now dealing with matrix     
  if(b_in != null && b_in instanceof jasymca.Matrix){
             Matrix mx = new Matrix(  b_in );
             double values[][] = mx.getDouble();
             double m[]=Statistics.mean(values);
             st.push( new Vektor(m).reduce() );
  }
  

  return 0;
 }
}


/*
@GROUP
statistics
@SYNTAX
mean([2,3,8])
@DOC
Calculates the mean value of matrix or a vector 
@EXAMPLES
<programlisting>
mean([4,2])
</programlisting>
@SEE
std, var, cov
*/
