package jasymca;

import jasymca.JasymcaException;
import jasymca.LambdaAlgebraic;
import jasymca.Unexakt;
import jasymca.Zahl;

class LambdaACOS extends LambdaAlgebraic{
 public LambdaACOS(){
  diffrule = "-1/sqrt(1-x^2)";
  intrule = "x*acos(x)-sqrt(1-x^2)";
  trigrule = "-i*log(x+i*sqrt(1-x^2))";
 }
 Zahl f( Zahl x) throws JasymcaException{
  Unexakt z = x.unexakt();
  if(z.imag == 0.)
   return new Unexakt(Math.acos(z.real));
  return (Zahl)evalx(trigrule, z);
 }
}


/*
@GROUP
trigonometric
@SYNTAX
angle = acos(value)
@DOC
Returns the arc cosine of value.
@EXAMPLES
<programlisting>
acos(1) = 0
acos(0) = 1.5707963267948966
</programlisting>
@SEE
cos, acosh, sin, asin, asinh
*/
