package jasymca;

import jasymca.JasymcaException;
import jasymca.LambdaAlgebraic;
import jasymca.Unexakt;
import jasymca.Zahl;

class LambdaASIN extends LambdaAlgebraic{
 public LambdaASIN(){
  diffrule = "1/sqrt(1-x^2)";
  intrule = "x*asin(x)+sqrt(1-x^2)";
  trigrule = "-i*log(i*x+i*sqrt(1-x^2))";
 }
 Zahl f( Zahl x) throws JasymcaException{
  Unexakt z = x.unexakt();
  if(z.imag == 0.)
   return new Unexakt(Math.asin(z.real));
  return (Zahl)evalx(trigrule, z);
 }
}

/*
@GROUP
trigonometric
@SYNTAX
angle=asin(value)
@DOC
Returns the arc sine of the first operand.
@EXAMPLES
<programlisting>
asin(1) = 1.5707963267948966
asin(0) = 0
</programlisting>
@SEE
sin, asinh, cos, acos, acosh
*/
