package jasymca;

import jasymca.Algebraic;
import jasymca.FunctionVariable;
import jasymca.JasymcaException;
import jasymca.LambdaAlgebraic;
import jasymca.Unexakt;
import jasymca.Zahl;

class LambdaATAN2 extends LambdaAlgebraic{
 Zahl f(Zahl x) throws JasymcaException{ return null;}
 Algebraic f_exakt(Algebraic x) throws JasymcaException{
  throw new JasymcaException("Usage: ATAN2(y,x).");
 }
 Algebraic f_exakt(Algebraic[] x) throws JasymcaException{
  throw new JasymcaException("Usage: ATAN2(y,x).");
 }
 Algebraic f_exakt(Algebraic x, Algebraic y) throws JasymcaException{
  if( y instanceof jasymca.Unexakt && !y.komplexq() &&
   x instanceof jasymca.Unexakt && !x.komplexq() )
   return new Unexakt( Math.atan2( ((Unexakt)y).real, ((Unexakt)x).real ) );
  if( !Zahl.ZERO.equals(x) ){
   return FunctionVariable.create("atan", y.div( x )).add(
      (FunctionVariable.create("sign",y).mult(Zahl.ONE.sub(
      (FunctionVariable.create("sign",x)))).mult(Zahl.PI).div(Zahl.TWO)));
  }else
   return (FunctionVariable.create("sign",y).mult(Zahl.PI).div(Zahl.TWO));
 }
}


/*
@GROUP
trigonometric
@SYNTAX
angle = atan2(value)
@DOC
Compute the atan2
@EXAMPLES
<programlisting>
</programlisting>
@NOTES
@SEE
cos, acosh, sin, asin, asinh
*/
