package jasymca;

import jasymca.*;

import java.util.Stack;
import jasymca.Lambda.*;



class LambdaCOS extends LambdaAlgebraic{
 public LambdaCOS(){
  diffrule = "-sin(x)";
  intrule = "sin(x)";
  trigrule = "1/2 *(exp(i*x)+exp(-i*x))";
 }
 Zahl f( Zahl x) throws JasymcaException{
  Unexakt z = x.unexakt();
  if(z.imag == 0.)
   return new Unexakt(Math.cos(z.real));
  return (Zahl)evalx(trigrule, z);
 }
 Algebraic f_exakt(Algebraic x) throws JasymcaException{
  if(x.equals(Zahl.ZERO))
   return Zahl.ONE;
  return null;
 }
}


/*
@GROUP
trigonometric
@SYNTAX
cos(angle)
@DOC
Returns the cosine of angle.
@EXAMPLES
cos(0) = 1
cos(1.5707963267948966) = 0
@SEE
acos, cosh
*/

