package jasymca;

import jasymca.*;
import java.util.Stack;
import jasymca.Lambda.*;


class LambdaSIN extends LambdaAlgebraic{
 public LambdaSIN(){
  diffrule = "cos(x)";
  intrule = "-cos(x)";
  trigrule = "1/(2*i)*(exp(i*x)-exp(-i*x))";
 }
 Zahl f( Zahl x) throws JasymcaException{
  Unexakt z = x.unexakt();
  if(z.imag == 0.)
   return new Unexakt(Math.sin(z.real));
  return (Zahl)evalx(trigrule, z);
 }
 Algebraic f_exakt(Algebraic x) throws JasymcaException{
  if(x.equals(Zahl.ZERO))
   return Zahl.ZERO;
  return null;
 }

}


/*
@@GROUP
trigonometric
@SYNTAX
answer = sin(angle)
@DOC
Returns the sine of angle.
@EXAMPLES
sin(0) = 0
sin(1.5708) = 1
@SEE
asin, sinh
*/

