package jasymca;

import jasymca.Algebraic;
import jasymca.JasymcaException;
import jasymca.LambdaAlgebraic;
import jasymca.Unexakt;
import jasymca.Zahl;

class LambdaTAN extends LambdaAlgebraic{
 public LambdaTAN(){
  diffrule = "1/(cos(x))^2";
  intrule = "-log(cos(x))"; // To do : add abs
  trigrule = "-i*(exp(i*x)-exp(-i*x))/(exp(i*x)+exp(-i*x))";
 }
 Zahl f( Zahl x) throws JasymcaException{
  Unexakt z = x.unexakt();
  if(z.imag == 0.)
   return new Unexakt(Math.tan(z.real));
  return (Zahl)evalx(trigrule, z);
 }
 Algebraic f_exakt(Algebraic x) throws JasymcaException{
  if(x.equals(Zahl.ZERO))
   return Zahl.ZERO;
  return null;
 }
}

/*
@GROUP
trigonometric
@SYNTAX
answer = tan(angle)
@DOC
Returns the tangent of angle.
@EXAMPLES
tan(0) = 0
tan(1) = 1.55740772
@SEE
atan, tanh
*/

