package  jmathlab;

import jmathlab.utils.BrowserLaunch;
import jmatmain.*;
import javax.swing.*;

import java.awt.Font;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.lang.Thread;



/**
 * Implementation of prompt
 * @author sergei
 *
 */
public class JPrompt  implements RemoteAccessible, ClipboardOwner
{

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**The area used for user input and where the answers are displayed*/
    private Console answer;

    /**The interpreter*/
     private static ConsoleService jasymcaConsole; 

     private Thread trun;

    /**
     * @param
     * @param
     */
    public void lostOwnership(Clipboard clip, Transferable cont)
    {
    }


   
    
    /**Create the main graphical interface (menu, buttons, delays...).*/
    public JPrompt()
    {
        
      
        trun=null;
        jasymcaConsole = new ConsoleService();

        answer = new Console(this);
       // add(answer);
        answer.displayPrompt();
        answer.requestFocus();
      //  this.validate();
    } // end GUI


    
    public JTextPane getTextArea(){
    	
    	return answer.getComponent();
}
   


    
    /**
     * Interpret the last command line entered
     * @param
     */
    public void interpretLine(final String s)
    {


        if (s.equals("help")){
           final String url = "http://jwork.org/jmathlab/";
           answer.displayText("% Launching a browser..");
           answer.displayPrompt();
           BrowserLaunch.openURL(url);
           return;
          }

       trun = new Thread("Executing a code line") {
        public void run() {
       jasymcaConsole.clear();
        String answerString=jasymcaConsole.exec(s);
        answer.displayText(answerString);
        answer.displayPrompt();
        String serr=jasymcaConsole.getError();
        if (serr.length()>1) ErrorMessage(serr);

      //  System.out.println("Input="+s);
      //  System.out.println("Answer="+answerString);
         };
       };
       trun.start();



    }











        private static void ErrorMessage(String a) {

                JOptionPane dialogError = new JOptionPane();
                JOptionPane.showMessageDialog(dialogError, a, "Error",
                                JOptionPane.ERROR_MESSAGE);
        }
   
    
    /**
     * Interpret the last command line entered
     * @param
     */
    public void interpretFile(final String filename)
    {
        

       trun = new Thread("Executing a file") {
        public void run() {
    
    	               String out=null;
    	    
			try {
				BufferedReader reader = new BufferedReader( new FileReader (filename));
				String         line = null;
	    	    StringBuilder  stringBuilder = new StringBuilder();
	    	    String         ls = System.getProperty("line.separator");

	    	    try {	    	    	
	    	    	while( ( line = reader.readLine() ) != null ) {
					    stringBuilder.append( line );
					    stringBuilder.append( ls );
					}
	    	    	 out=stringBuilder.toString();	    	    	
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}			
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
    	    
   
	if (out == null) return;
    	
   
    	jasymcaConsole.clear();
        String answerString=jasymcaConsole.exec(out);
        answer.displayText(answerString);
        answer.displayPrompt();

         String serr=jasymcaConsole.getError();
         if (serr.length()>1) ErrorMessage(serr);

      //  System.out.println("Input="+s);
      //  System.out.println("Answer="+answerString);



         };
       };
       trun.start();

    }
    
    
    /**
     * Set font
     * @param font
     */
    public void setFontText(Font font){
    	
    	answer.setFont(font);
    }
    
    /**
     * Clear output
     * @param font
     */
    public void clear(){
    	
    	jasymcaConsole.clear();
    	jasymcaConsole = new ConsoleService();
    	answer.clear();
    }
    
    
    
    /**
     * displays the output of an evaluation
     * @param  text to display
     */
    public void displayText(String text)
    {
        answer.displayText(text);
    }




	@Override
	public void close() {
	//	clear();
		
	}
    
    

}
