// * This code is licensed under:
// * jeHEP License, Version 1.0
// * - for license details see http://jehep.sourceforge.net/license.html 
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.
package jmathlab.utils;

import java.awt.*;
import javax.swing.*;
import java.net.*;


/**
 * A class to build a help for each canvas.
 * @author S.Chekanov
 *
 */
public class HelpDialog extends JDialog {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JButton closeButton;
	private Component win;
	private String html_file;

	
	/**
	 * Show a help frame
	 * @param win  parent window
	 * @param html_file html file
	 */
	public HelpDialog(Component win, String html,int xmin, int xmax ) {

		this.win = win;
	        html_file = html;

		setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);

		setTitle("Help");
		setModal(true);
		setResizable(true);


                 JEditorPane epane = new JEditorPane();
                epane.setContentType("text/html;charset=ISO-8859-1");
                // JTextPane  epane = new JTextPane();
                // epane.setContentType("text/html"); // lets Java know it will be HTML 
                // epane.setAutoscrolls(true);
                epane.setEditable(false);
                epane.setText(html_file);
                /*
                try {
                        epane.setPage(getHTMLUrl(html_file));
                } catch (Exception e) {
                        System.err.println("Couldn't create URL");
                        epane.setContentType("text/plain");
                }
                */
                JScrollPane topPanel = new JScrollPane(epane);

		// Get the system resolution
		Dimension res = Toolkit.getDefaultToolkit().getScreenSize();

		// make sure the dialog is not too big
		Dimension size = new Dimension(Math.min(xmin, res.width), Math.min(xmax,
				res.height));

		// setLocationRelativeTo(parent);

		JPanel lowerPanel = new JPanel();
		lowerPanel.setPreferredSize(new Dimension(xmin, 35));
		closeButton = new JButton();
		closeButton.setText("Close");
		closeButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				setVisible(false);
				dispose();
			}
		});

		lowerPanel.add(closeButton, null);
                // topPanel.setLayout(new BorderLayout());
                getContentPane().add(topPanel, java.awt.BorderLayout.CENTER);
                getContentPane().add(lowerPanel, java.awt.BorderLayout.SOUTH);


		// Util.centreWithin(win, this);
		// set visible and put on center
                setSize(size);
		setVisible(true);
	}


          public HelpDialog(Component win, String html) {
              this(win,html,400,400);
           }


           /**
         * Returns a HTML page which is found in a valid image URL. The basis of the
         * url is where 'intro' is created, which can't be but the place where
         * JChess resides.
         *
         * @param name
         *            name of the HTML page
         * @return the URL to the page
         */
        public URL getHTMLUrl(String name) {
                URL url = null;
                try {
                        url = this.getClass().getResource(name);
                } catch (Exception e) {
                }
                return url;
        }

}
