package jmathlab.utils;

import javax.swing.JOptionPane;

import java.awt.Color;
import java.util.Arrays;
import java.util.HashMap;
import java.util.StringTokenizer;
import java.lang.reflect.Field;
/**
 * Class to get options
 * 
 * @author sergei chekanov
 * 
 */
public class UtilsOptions {

	public HashMap<String, String> map;

	/**
	 * Initialise optio file
	 * 
	 * @param foo
	 */
	public UtilsOptions(String foo) {

                foo= foo.trim();
		map = new HashMap<String, String>();

                if (foo.indexOf(";")==-1) {
                        StringTokenizer st2 = new StringTokenizer(foo, "=");
                        map.put((st2.nextToken()).trim(), (st2.nextToken()).trim());
                        return;
                        } 

		StringTokenizer st = new StringTokenizer(foo, ";");
		while (st.hasMoreTokens()) {
			String thisToken = st.nextToken();
			StringTokenizer st2 = new StringTokenizer(thisToken, "=");
			map.put((st2.nextToken()).trim(), (st2.nextToken()).trim());
		}
        return;
	}

	/**
	 * Get string value
	 * 
	 * @param key
	 *            key
	 * @param defo
	 *            default string
	 * @return value
	 */
	public String getStringValue(String key, String defo) {

		if (!map.containsKey(key))
			return defo;
		else
			return map.get(key).toString();
	}

	
	
	
	/**
	 * Get string value
	 * 
	 * @param key
	 *            key
	 * @param defo
	 *            default string
	 * @return value
	 */
	public Color getColorValue(String key, Color defo) {

		if (!map.containsKey(key))
			return defo;
		else {
			String a = map.get(key).toString();
			return stringToColor(a);
	        
		}
		}
	
	
	
	public static Color stringToColor(final String value) {
	    if (value == null) {
	      return Color.black;
	    }
	    try {
	      // get color by hex or octal value
	      return Color.decode(value);
	    } catch (NumberFormatException nfe) {
	      // if we can't decode lets try to get it by name
	      try {
	        // try to get a color by name using reflection
	        final Field f = Color.class.getField(value);

	        return (Color) f.get(null);
	      } catch (Exception ce) {
	        // if we can't get any color return black
	        return Color.black;
	      }
	    }
	  }
	
	


         /**
         * Get bool value
         * 
         * @param key
         * @param defo
         * @return
         */

        public boolean getBooleanValue(String key, boolean defo) {
                if (!map.containsKey(key))
                        return defo;
                else {
                        String aa = map.get(key).toString();
                        if (aa.equals("false")) return false;
                        if (aa.equals("true"))  return  true;
                }
            return defo;
        }
	
	
	
	/**
	 * Get integer value
	 * 
	 * @param key
	 * @param defo
	 * @return
	 */

	public int getIntValue(String key, int defo) {
		if (!map.containsKey(key))
			return defo;
		else {
			String aa = map.get(key).toString();
			int out = defo;
			try {
				out = Integer.parseInt(aa);
			} catch (NumberFormatException e) {
				return defo;
			}

			return out;
		}
	}

	/**
	 * get double value
	 * 
	 * @param key
	 * @param defo
	 * @return
	 */
	public double getDoubleValue(String key, double defo) {
		if (!map.containsKey(key))
			return defo;
		else {
			String aa = map.get(key).toString();
			double out = defo;
			try {
				out = Integer.parseInt(aa);
			} catch (NumberFormatException e) {
				return defo;
			}

			return out;
		}
	}

}
